#include <stdio.h>
#include <unistd.h>
#include <math.h>

#include "gg_simple_client.h"

#define COLS 24
#define ROWS 4
#define FRAME_DURATION 1.0f/30*1e3

int main(int argc, char *argv[]) {
  gg_frame *f;
  gg_socket *s;

  int i = 0;

  float ball_dir = 1.0;
  float ball_slope = 0.3;
  float ball_x = 0.0;
  float ball_y = (float)(ROWS/2);

  f = gg_init_frame(COLS, ROWS, 3);
  //s = gg_init_socket("localhost", 0xabac);
  s = gg_init_socket("localhost", 0xacab);

  /* 30 fps */
  gg_set_duration(s, FRAME_DURATION);

  for (i = 0; i < 2000; ++i) {
	  gg_set_pixel_color( f, (int)ball_x, (int)ball_y,
			  (uint8_t)(0),
			  (uint8_t)(0),
			  (uint8_t)(0) );

	  //move ball
	  ball_x += ball_dir;
	  if( ball_x >= (float)COLS || ball_x <= 0.0 ) {
		  ball_dir *= -1.0;
	  }
	  ball_y += ball_slope;
	  if( ball_y >= (float)ROWS || ball_y <= 0.0 ) {
		  ball_slope *= -1.0;
	  }

	  gg_set_pixel_color( f, (int)ball_x, (int)ball_y,
			  (uint8_t)(255),
			  (uint8_t)(255),
			  (uint8_t)(255) );

    printf("Sent frame %d (%.2f, %.2f)\n", i, ball_x, ball_y);
    gg_send_frame(s, f);
	usleep( 100000l );
	if( !(i % 500 ) ) {
		usleep( 1000000l );
	}
  }

  gg_deinit_frame(f);
  gg_deinit_socket(s);

  return 0;
}
